<?php
/*  
Copyright:  2010 Haden Software <http://haden.cc/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/

/**************************************************************************************************/
/* Direct access denial.                                                                          */
/**************************************************************************************** 0.9.0 ***/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit("Do not access this file directly.");

/**************************************************************************************************/
/* Function to add our options to the s2Member options pages                                      */
/**************************************************************************************** 0.9.0 ***/
if (!function_exists ("hsmember_menu_add_admin_options")) {
  function hsmember_menu_add_admin_options() {
	do_action ("hsmember_menu_before_add_admin_options",get_defined_vars ());
	add_menu_page("HS-Membership Options", 
                  "HS-Member", 
                  "edit_plugins", 
                  "hsmember-menu-options", 
                  "hsmember_menu_options_general_page");
	add_submenu_page("hsmember-menu-options",
		             "HS Member Options",
                     "General Options",
		             "edit_plugins", 
		             "hsmember-menu-options",
		             "hsmember_menu_options_general_page");
    do_action ("hsmember_menu_after_add_admin_options",get_defined_vars ());
  } // end of hsmember_menu_add_admin_options()
}

/**************************************************************************************************/
/* Function to add the Multi-Site Membership options page                                         */
/**************************************************************************************** 0.9.0 ***/
if (!function_exists ("hsmember_menu_options_general_page")) {
	function hsmember_menu_options_general_page() {
		do_action ("hsmember_menu_before_options_general_page", get_defined_vars ());
		hsmember_menu_update_all_options ();
		include_once dirname(dirname(__FILE__))."/option-pages/hsm-opt-general.php";
		do_action("hsmember_menu_after_options_general_page", get_defined_vars ());
		return;
	} // end of hsmember_menu_options_general_page()
}

/**************************************************************************************************/
/* Function to save/update all plugin option values                                               */
/**************************************************************************************** 0.9.0 ***/
if (!function_exists ("hsmember_menu_update_all_options")) {
  function hsmember_menu_update_all_options () {
    do_action ("hsmember_menu_before_update_all_options", get_defined_vars ());
    if (($lv_nonce = $_POST["hsmember_options_nonce"]) && 
        wp_verify_nonce($lv_nonce,"hsmember-options-nonce")) {
      $lv_options = $GLOBALS["_HSMEMBER_"]["o"];
      foreach ($_POST as $lv_key => $lv_value) {
        if (preg_match("/^".preg_quote ("hsmember","/")."/",$lv_key)) {
          (is_array($lv_value)) ? array_shift ($lv_value) : null;
					$lv_options[preg_replace("/^".preg_quote("hsmember_options_","/")."/","",$lv_key)] = $lv_value;
        }
      }
			$lv_options["options_version"] = $GLOBALS["_HSMEMBER_"]["o"]["options_version"] + 0.001;
			$lv_options = hsmember_configure_option_defaults($lv_options); // Also updates the GLOBALS array.
      // Override the main options values, this need to be done as BuddyPress use a cached version of
      //  the system variables so the pre_site_option filter dont always work.
      if ( $GLOBALS["_HSMEMBER_"]["o"]["blog_create_access"] &&
          ($GLOBALS["_HSMEMBER_"]["o"]["blog_create_access"] > 0)) {
        update_site_option('registration','user');
      }
			eval('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
			do_action ("hsmember_menu_during_update_all_options",get_defined_vars ());
			unset ($__refs, $__v);
			update_option("hsmember_options",$lv_options);
    }
		do_action ("hsmember_menu_after_update_all_options", get_defined_vars ());
		return;
	} // end of hsmember_menu_update_all_options()
}
?>